Attribute VB_Name = "SloupDump"
Option Explicit
Public foo As Integer
Public FileNum

Public Sub DumpAviBD(ByVal NewtConnect As MSComm)
    On Error GoTo EHandler
    Dim CurrentDate As Date
    Dim EndDate As Date
    mainform.UpdateStatus ("Getting Avi's BD Scribble Area...")
    mainform.Refresh
    NewtConnect.Output = "EVAL!GetRoot().|Avi's Backdrop:AviD|.editArea.viewChildren[0].text" & Chr(13)
    
    CurrentDate = Now
    EndDate = DateAdd("s", 3, CurrentDate)

    Dim StrResult As String
    While Not (EndDate = Now)
        StrResult = StrResult + NewtConnect.Input
        DoEvents
    Wend
    
    ShowAviText.avitext = StrResult
    ShowAviText.Show
    Call SerialFunc.ClosePort(NewtConnect)
    
    mainform.UpdateStatus ("Done retrieving info from Avi's BD")
    mainform.Refresh
    Exit Sub
EHandler:
    If Err.Number > 8000 And Err.Number < 8022 Then
        foo = MsgBox("Serial comm error.  Is Sloup running?  Is the cable plugged in?  Is the right COM port selected?", vbExclamation)
        NewtConnect.PortOpen = False
        
    End If
End Sub

Public Sub DumpFortunes(ByVal OutFile As String, NewtConnect As MSComm)
    On Error GoTo EHandler
    FileNum = FreeFile
    Open OutFile For Append As FileNum
    
    mainform.UpdateStatus ("Processing Fortunes...")
    mainform.Refresh
    
    NewtConnect.Output = "Sloup" & Chr(13)
    NewtConnect.Output = "{}" & Chr(13)
    NewtConnect.Output = "Fortunes:Kallisys" & Chr(13)
    NewtConnect.Output = "{text: 'string}" & Chr(13)
    NewtConnect.Output = "DUMP!{recordDelimiter: " & Chr(34) & "%" & Chr(34) & ", fieldDelimiter: " & Chr(34) & _
        "\n" & Chr(34) & "}" & Chr(13)
    
    Dim StrResult As String
    While InStr(StrResult, "BYE!") = 0
        StrResult = StrResult + NewtConnect.Input
        DoEvents
    Wend
    
    StrResult = Replace(StrResult, Chr(13) & Chr(13), vbNewLine)
    StrResult = Replace(StrResult, Chr(13), vbNewLine)
    StrResult = Replace(StrResult, "BYE!", "")
    Print #FileNum, StrResult
    Close #FileNum
    
    mainform.UpdateStatus ("Fortunes dump complete!")
    mainform.Refresh
    
    Close #FileNum
    Exit Sub
EHandler:
    If Err.Number > 8000 And Err.Number < 8022 Then
        foo = MsgBox("Serial comm error.  Is Sloup running?  Is the cable plugged in?  Is the right COM port selected?", vbExclamation)
        NewtConnect.PortOpen = False
    End If

End Sub


Public Sub DumpCalendar(ByVal temporaryFile As String, ByVal OutFile As String, NewtConnect As MSComm)
    On Error GoTo EHandler
    FileNum = FreeFile
    Open temporaryFile For Append As FileNum
    '// first, dump Meeting info (non-repeating)
    
    '// SEND SLOUP COMMANDS
    '// reset Sloup
    NewtConnect.Output = "Sloup" & Chr(13)
    NewtConnect.Output = "{}" & Chr(13)
    NewtConnect.Output = "Calendar" & Chr(13)
    NewtConnect.Output = "{viewStationery : 'Meeting, mtgStartDate: " & Chr(34) & "time" & Chr(34) & _
        ", mtgDuration: " & Chr(34) & "int" & Chr(34) & ", mtgText: 'string, mtgAlarm: " & Chr(34) & _
        "time" & Chr(34) & "}" & Chr(13)
    NewtConnect.Output = "DUMP!{fieldDelimiter: " & Chr(34) & "\n" & Chr(34) & ", recordDelimiter: " & Chr(34) _
        & "|||||" & Chr(34) & "}" & Chr(13)
    
    mainform.UpdateStatus ("Processing Dates (normal meetings)...")
    mainform.Refresh
    
    Dim StrResult As String
    While InStr(StrResult, "BYE!") = 0
        StrResult = StrResult + NewtConnect.Input
        DoEvents
    Wend
    
    Print #FileNum, StrResult
    Close #FileNum
    
    mainform.UpdateStatus ("Meetings dump complete!")
    mainform.Refresh
    Call ParseCalendar(temporaryFile, OutFile)
    
    FileNum = FreeFile
    Open temporaryFile For Append As FileNum
    '// next, dump Events info (non-repeating)
    '// SEND SLOUP COMMANDS
    '// reset Sloup
    NewtConnect.Output = "Sloup" & Chr(13)
    NewtConnect.Output = "{}" & Chr(13)
    '// get our data (all meetings (excl. repeat meetings))
    NewtConnect.Output = "Calendar Notes" & Chr(13)
    NewtConnect.Output = "{mtgStartDate: " & Chr(34) & "time" & Chr(34) & ", mtgText: 'string, mtgAlarm: " & _
        Chr(34) & "time" & Chr(34) & "}" & Chr(13)
    NewtConnect.Output = "DUMP!{fieldDelimiter: " & Chr(34) & "\n" & Chr(34) & ", recordDelimiter: " & Chr(34) _
        & "|||||" & Chr(34) & "}" & Chr(13)
    
    mainform.UpdateStatus ("Processing Dates (normal events)...")
    mainform.Refresh

    StrResult = ""
    While InStr(StrResult, "BYE!") = 0
        StrResult = StrResult + NewtConnect.Input
        DoEvents
    Wend
    
    Print #FileNum, StrResult
    Close #FileNum
    
    mainform.UpdateStatus ("Events dump complete!")
    mainform.Refresh
    Call ParseEvents(temporaryFile, OutFile)
    
    If mainform.deletedata = 1 Then
        Call deletedata("Calendar", NewtConnect)
        Call deletedata("Calendar Notes", NewtConnect)
    End If
    Exit Sub

EHandler:
    If Err.Number > 8000 And Err.Number < 8022 Then
        foo = MsgBox("Serial comm error.  Is Sloup running?  Is the cable plugged in?  Is the right COM port selected?", vbExclamation)
        NewtConnect.PortOpen = False
    End If

End Sub

Public Sub DumpCalls(ByVal temporaryFile As String, ByVal OutFile As String, NewtConnect As MSComm)
    On Error GoTo EHandler
    '// dumps Calls data to disk
    FileNum = FreeFile
    Open temporaryFile For Append As FileNum
    
    '// SEND SLOUP COMMANDS
    '// reset Sloup
    NewtConnect.Output = "Sloup" & Chr(13)
    NewtConnect.Output = "{}" & Chr(13)
    '// get our data (all Calls)
    NewtConnect.Output = "Calls" & Chr(13)
    NewtConnect.Output = "{callDate: " & Chr(34) & "dateTime" & Chr(34) & ", name: 'string, phoneNumber: 'string, " _
        & "notes: [" & Chr(34) & "para" & Chr(34) & "]}" & Chr(13)
    NewtConnect.Output = "DUMP!{fieldDelimiter: " & Chr(34) & "\n" & Chr(34) & ", recordDelimiter: " & Chr(34) _
        & "|||||" & Chr(34) & "}" & Chr(13)
    
    mainform.UpdateStatus ("Processing Calls...")
    mainform.Refresh
    
    Dim StrResult As String
    While InStr(StrResult, "BYE!") = 0
        StrResult = StrResult + NewtConnect.Input
        DoEvents
    Wend
    
    Print #FileNum, StrResult
    Close #FileNum
    
    mainform.UpdateStatus ("Calls dump complete!")
    mainform.Refresh
    
    Exit Sub

EHandler:
    If Err.Number > 8000 And Err.Number < 8022 Then
        foo = MsgBox("Serial comm error.  Is Sloup running?  Is the cable plugged in?  Is the right COM port selected?", vbExclamation)
        NewtConnect.PortOpen = False
    End If
    
    
End Sub
Public Sub DumpQuotes(ByVal temporaryFile As String, ByVal OutFile As String, NewtConnect As MSComm)
    On Error GoTo EHandler
    '// dumps Quotes data (http://www.kallisys.com/newton/quotes/) to disk.
    FileNum = FreeFile
    Open temporaryFile For Append As FileNum
    
    '// SEND SLOUP COMMANDS
    '// reset Sloup
    NewtConnect.Output = "Sloup" & Chr(13)
    NewtConnect.Output = "{}" & Chr(13)
    '// get our data (all Quotes entries)
    NewtConnect.Output = "Quotes:Paul's Software" & Chr(13)
    NewtConnect.Output = "{author: 'string, source: 'string, quote: 'string}" & Chr(13)
    NewtConnect.Output = "DUMP!{fieldDelimiter: " & Chr(34) & "\n" & Chr(34) & ", recordDelimiter: " & Chr(34) _
        & "|||||" & Chr(34) & "}" & Chr(13)
    
    mainform.UpdateStatus ("Processing Quotes...")
    mainform.Refresh
    
    '// RECIEVE DATA - this loop lifted from Notes2Notes
    Dim StrResult As String
    While InStr(StrResult, "BYE!") = 0
        StrResult = StrResult + NewtConnect.Input
        DoEvents
    Wend
    
    '// write strResult to the file and close it
    Print #FileNum, StrResult
    Close #FileNum
    
    mainform.UpdateStatus ("Quotes dump complete!")
    mainform.Refresh
    Call ParseQuotes(temporaryFile, OutFile)
    If mainform.deletedata = 1 Then
        Call deletedata("Quotes", NewtConnect)
    End If
    
    Exit Sub

EHandler:
    If Err.Number > 8000 And Err.Number < 8022 Then
        foo = MsgBox("Serial comm error.  Is Sloup running?  Is the cable plugged in?  Is the right COM port selected?", vbExclamation)
        NewtConnect.PortOpen = False
    End If
        
End Sub

Public Sub DumpOutBox(ByVal temporaryFile As String, ByVal OutFile As String, NewtConnect As MSComm)
    On Error GoTo EHandler
    '// This Subroutine dumps the OutBox data to disk.
    Dim StrResult As String
    Dim badChr As Integer
    badChr = 0
    FileNum = FreeFile
    Open temporaryFile For Append As FileNum

    '// SEND SLOUP COMMANDS
    '// reset Sloup settings
    NewtConnect.Output = "Sloup" & Chr(13)
    NewtConnect.Output = "{}" & Chr(13)
    '// get our data (SimpleMail messages only?)
    NewtConnect.Output = "OutBox" & Chr(13)
    NewtConnect.Output = "{_modTime: " & Chr(34) & "DateTimeSpecs:[@66.dayStrSpec, nil, @66.longTimeStrSpec]" _
        & Chr(34) & ", timestamp: " & Chr(34) & "DateTimeSpecs:[@66.numericYearStrSpec, nil, nil]" & Chr(34) _
        & ", fromRef: {name: {first: 'string, last: 'string}, email: 'string}, title: 'string, toRef: [{name: {first: 'string, last: 'string}, email: 'string}], body: {text: 'string}}" & Chr(13)
    NewtConnect.Output = "DUMP!{fieldDelimiter: " & Chr(34) & "\n" & Chr(34) & ", recordDelimiter: " & Chr(34) _
        & "|||||" & Chr(34) & "}" & Chr(13)
    
    mainform.UpdateStatus ("Processing OutBox...")
    mainform.Refresh
    
    '// RECIEVE DATA - this loop lifted from Notes2Notes
    While InStr(StrResult, "BYE!") = 0
        StrResult = StrResult + NewtConnect.Input
        DoEvents
    Wend
    
    '// FIX DATA - change any control characters to spaces
    While badChr < 10
        StrResult = Replace(StrResult, Chr(badChr), " ")
        badChr = badChr + 1
        mainform.UpdateStatus ("Fixing OutBox data (step 1) " & badChr)
        DoEvents
    Wend
    badChr = 11
    While badChr < 13
        StrResult = Replace(StrResult, Chr(badChr), " ")
        badChr = badChr + 1
        mainform.UpdateStatus ("Fixing OutBox data (step 1) " & badChr)
        DoEvents
    Wend
    badChr = 14
    While badChr < 32
        StrResult = Replace(StrResult, Chr(badChr), " ")
        badChr = badChr + 1
        mainform.UpdateStatus ("Fixing OutBox data (step 2) " & badChr)
        DoEvents
    Wend
    badChr = 128
    While badChr < 255
        StrResult = Replace(StrResult, Chr(badChr), " ")
        badChr = badChr + 1
        mainform.UpdateStatus ("Fixing OutBox data (step 3) " & badChr)
        DoEvents
    Wend
    '// write strResult to the file and close it
    Print #FileNum, StrResult
    Close #FileNum
    
    mainform.UpdateStatus ("OutBox dump complete!")
    mainform.Refresh
    Call ParseIOB(temporaryFile, OutFile)
    If mainform.deletedata = 1 Then
        Call deletedata("OutBox", NewtConnect)
    End If
    
    Exit Sub

EHandler:
    If Err.Number > 8000 And Err.Number < 8022 Then
        foo = MsgBox("Serial comm error.  Is Sloup running?  Is the cable plugged in?  Is the right COM port selected?", vbExclamation)
        NewtConnect.PortOpen = False
    End If

End Sub

Public Sub DumpInBox(ByVal temporaryFile As String, ByVal OutFile As String, NewtConnect As MSComm)
    On Error GoTo EHandler
    '// This Subroutine dumps the InBox data to disk.
    Dim StrResult As String
    Dim badChr As Integer
    FileNum = FreeFile
    badChr = 0
    Open temporaryFile For Append As FileNum
    
    '// SEND SLOUP COMMANDS
    '// reset Sloup settings
    NewtConnect.Output = "Sloup" & Chr(13)
    NewtConnect.Output = "{}" & Chr(13)
    '// get the inbox data (SimpleMail messages only?)
    NewtConnect.Output = "InBox" & Chr(13)
    NewtConnect.Output = "{_modTime: " & Chr(34) & "DateTimeSpecs:[@66.dayStrSpec, nil, @66.longTimeStrSpec]" _
        & Chr(34) & ", timestamp: " & Chr(34) & "DateTimeSpecs:[@66.numericYearStrSpec, nil, nil]" & Chr(34) _
        & ", fromRef: {name: {first: 'string, last: 'string}, email: 'string}, " _
        & "title: 'string, toRef: [{name: {first: 'string, last: 'string}, email: 'string}], body: {text: 'string}}" _
        & Chr(13)

    NewtConnect.Output = "DUMP!{fieldDelimiter: " & Chr(34) & "\n" & Chr(34) & ", recordDelimiter: " & Chr(34) _
        & "|||||" & Chr(34) & "}" & Chr(13)
    
    mainform.UpdateStatus ("Processing InBox...")
    mainform.Refresh
    
    '// RECIEVE DATA - this loop lifted from Notes2Notes
    While InStr(StrResult, "BYE!") = 0
        StrResult = StrResult + NewtConnect.Input
        DoEvents
    Wend
    
    mainform.UpdateStatus ("Fixing InBox data...")
    
    '// FIX DATA - change any control characters to spaces
    While badChr < 10
        StrResult = Replace(StrResult, Chr(badChr), " ")
        badChr = badChr + 1
        mainform.UpdateStatus ("Fixing Inbox data (step 1) " & badChr)
        DoEvents
    Wend
    badChr = 11
    While badChr < 13
        StrResult = Replace(StrResult, Chr(badChr), " ")
        badChr = badChr + 1
        mainform.UpdateStatus ("Fixing Inbox data (step 1) " & badChr)
        DoEvents
    Wend
    badChr = 14
    While badChr < 32
        StrResult = Replace(StrResult, Chr(badChr), " ")
        badChr = badChr + 1
        mainform.UpdateStatus ("Fixing Inbox data (step 2) " & badChr)
        DoEvents
    Wend
    badChr = 128
    While badChr < 255
        StrResult = Replace(StrResult, Chr(badChr), " ")
        badChr = badChr + 1
        mainform.UpdateStatus ("Fixing Inbox data (step 3) " & badChr)
        DoEvents
    Wend
    
    '// WRITE DATA TO DISK
    Print #FileNum, StrResult
    Close #FileNum

    mainform.UpdateStatus ("InBox dump complete!")
    mainform.Refresh
    Call ParseIOB(temporaryFile, OutFile)
    If mainform.deletedata = 1 Then
        Call deletedata("InBox", NewtConnect)
    End If
    
    Exit Sub

EHandler:
    If Err.Number > 8000 And Err.Number < 8022 Then
        foo = MsgBox("Serial comm error.  Is Sloup running?  Is the cable plugged in?  Is the right COM port selected?", vbExclamation)
        NewtConnect.PortOpen = False
    End If

End Sub

Public Sub DumpNames(ByVal temporaryFile As String, ByVal OutFile As String, NewtConnect As MSComm, CSV As Boolean)
    On Error GoTo EHandler
    '// This subroutine dumps the Names data to disk.
    Dim StrResult As String
    FileNum = FreeFile
    
    Open temporaryFile For Append As FileNum
    
    '// SEND SLOUP COMMANDS
    '// reset Sloup settings
    NewtConnect.Output = "Sloup" & Chr(13)
    NewtConnect.Output = "{}" & Chr(13)
    '// get the Card data
    NewtConnect.Output = "Names" & Chr(13)
    NewtConnect.Output = "{_modTime: " & Chr(34) & "dateTimeSpecs:[@66.numericDateStrSpec, nil, @66.shortTimeStrSpec]" _
        & Chr(34) & ", class: " & Chr(34) & "string" & Chr(34) & ", name: {honorific: " & Chr(34) & "string" _
        & Chr(34) & ", first: " & Chr(34) & "string" & Chr(34) & ", last: " & Chr(34) & "string" & Chr(34) _
        & "}, title: " & Chr(34) & "string" & Chr(34) & ", company: " & Chr(34) & "string" & Chr(34) & ", phones: [" _
        & Chr(34) & "homePhone" & Chr(34) & ", " & Chr(34) & "workPhone" & Chr(34) & ", " & Chr(34) & "beeperPhone" _
        & Chr(34) & ", " & Chr(34) & "faxPhone" & Chr(34) & "], email: " & Chr(34) & "string" & Chr(34) _
        & ", address: " & Chr(34) & "string" & Chr(34) & ", address2: " & Chr(34) & "string" & Chr(34) & ", city: " _
        & Chr(34) & "string" & Chr(34) & ", region: " & Chr(34) & "string" & Chr(34) & ", country: " & Chr(34) _
        & "string" & Chr(34) & ", postal_code: " & Chr(34) & "string" & Chr(34) & ", bday: " & Chr(34) & "date" _
        & Chr(34) & "}" & Chr(13)
    NewtConnect.Output = "DUMP!{fieldDelimiter: " & Chr(34) & "\n" & Chr(34) & ", recordDelimiter: " & Chr(34) _
        & "|||||" & Chr(34) & "}" & Chr(13)
    
    mainform.UpdateStatus ("Processing Names...")
    '// RECIEVE DATA - this loop lifted from Notes2Notes
    While InStr(StrResult, "BYE!") = 0
        StrResult = StrResult + NewtConnect.Input
        DoEvents
    Wend
    
    Print #FileNum, StrResult
    Close #FileNum
    mainform.UpdateStatus ("Names dump complete!")
    mainform.Refresh
    If CSV = True Then
        Call ParseCSVNames(temporaryFile, OutFile)
    Else
        Call ParseNames(temporaryFile, OutFile)
    End If
    If mainform.deletedata = 1 Then
        Call deletedata("Names", NewtConnect)
    End If
    
    Exit Sub

EHandler:
    If Err.Number > 8000 And Err.Number < 8022 Then
        foo = MsgBox("Serial comm error.  Is Sloup running?  Is the cable plugged in?  Is the right COM port selected?", vbExclamation)
        NewtConnect.PortOpen = False
    End If

End Sub

Public Sub deletedata(ByVal SoupName As String, NewtConnect As MSComm)
    Dim question As Boolean
    
    question = MsgBox("Data has been saved successully.  Do you wish to clear the " & SoupName & " soup on your Newton?", vbYesNo + vbQuestion, "Delete Data?")
    
    If question = VbMsgBoxResult.vbYes Then
        question = MsgBox("All data in " & SoupName & " will be deleted!  ARE YOU SURE?", vbCritical + vbYesNo, "Are you sure?")
        If question = VbMsgBoxResult.vbYes Then
            NewtConnect.Output = "Sloup" & Chr(13)
            NewtConnect.Output = "{}" & Chr(13)
            NewtConnect.Output = ""
            NewtConnect.Output = SoupName & Chr(13)
            NewtConnect.Output = "{}" & Chr(13)
            NewtConnect.Output = "DELETE!" & Chr(13)
        End If
        question = MsgBox("Data in " & SoupName & " deleted.", vbOKOnly)
    End If
End Sub

Public Function DumpPackage(ByVal PackageName As String, ByVal temporaryFile As String, ByVal OutFile As String, NewtConnect As MSComm)
    On Error GoTo EHandler
    '// this subroutine prompts for a package name and dumps it to a file.
    Dim FileNum2 As Integer
    Dim StrResult As String
    Dim ByteStr As String
    Dim StrPos As Integer
    Dim PackageOutput As String
    Dim foobarbaz As Integer
    Dim TempLine As String
    Dim tempbyte As Byte
    FileNum = FreeFile
    FileNum2 = FreeFile(1)
    
    Call OpenPort(NewtConnect)
    
    If PackageName = "" Then
        Exit Function
    End If
    
    Open temporaryFile For Append As FileNum
    '// SEND SLOUP COMMANDS
    '// reset Sloup settings
    NewtConnect.Output = "Sloup" & Chr(13)
    NewtConnect.Output = "{}" & Chr(13)
    '// get the package data
    NewtConnect.Output = "Package" & Chr(13) & "{packageName: " & Chr(34) & PackageName & Chr(34) & ", packageEntry: " _
        & Chr(34) & "binary:packageEntry" & Chr(34) & "}" & Chr(13)
    NewtConnect.Output = "DUMP!" & Chr(13)
    
    mainform.UpdateStatus ("Recieving package data...")
    mainform.Refresh
    
    '// RECIEVE DATA - this loop lifted from Notes2Notes
    While InStr(StrResult, "BYE!") = 0
        StrResult = StrResult + NewtConnect.Input
        DoEvents
    Wend
    
    Print #FileNum, StrResult
    Close #FileNum
    
    mainform.UpdateStatus ("Decoding package data...")
    mainform.Refresh
    
    foobarbaz = decode_package(temporaryFile, OutFile)
    
    mainform.UpdateStatus ("Package " & PackageName & " saved successfully.")
    Kill temporaryFile
    mainform.Refresh
    Call ClosePort(NewtConnect)
    
    Exit Function

EHandler:
    If Err.Number > 8000 And Err.Number < 8022 Then
        foo = MsgBox("Serial comm error.  Is Sloup running?  Is the cable plugged in?  Is the right COM port selected?", vbExclamation)
        NewtConnect.PortOpen = False
    End If

End Function

Public Sub DumpNotes(ByVal temporaryFile As String, ByVal OutFile As String, NewtConnect As MSComm)
    On Error GoTo EHandler
    '// maybe a future feature?
    Dim CountEntry As Integer
    Dim SomeString As String
    FileNum = FreeFile
    CountEntry = 0
    Open temporaryFile For Append As FileNum
    
    '// SEND SLOUP COMMANDS
    '// reset Sloup Settings
    NewtConnect.Output = "Sloup" & Chr(13)
    NewtConnect.Output = "{}" & Chr(13)
    '// get notes data
    NewtConnect.Output = "Notes" & Chr(13)
    NewtConnect.Output = "{class: 'paperroll, title: " & Chr(34) & "string" & Chr(34) & ", _modTime: " & Chr(34) _
        & "dateTime" & Chr(34) & "}" & Chr(13)
    NewtConnect.Output = "DUMP!{fieldDelimiter: " & Chr(34) & "\n" & Chr(34) & ", recordDelimiter: " & Chr(34) _
        & "\n---------------\n" & Chr(34) & ", soupDelimiter: " & Chr(34) & "Exported by NewtDump" & Chr(34) & "}" & Chr(13)

    
    mainform.UpdateStatus ("Processing Notes...")
    mainform.Refresh
    
    '// RECIEVE DATA - this loop lifted from Notes2Notes
    Dim StrResult As String
    While InStr(StrResult, "Exported by NewtDump") = 0
        StrResult = StrResult + NewtConnect.Input
        DoEvents
    Wend
    
    '// WRITE DATA TO DISK
    Print #FileNum, StrResult
    Close #FileNum
    
    '// lameness - copy temp file to the real file
    FileCopy temporaryFile, OutFile
    Kill temporaryFile
    mainform.UpdateStatus ("Notes dump complete!")
    mainform.Refresh
    If mainform.deletedata = 1 Then
        Call deletedata("Notes", NewtConnect)
    End If
    
    Exit Sub

EHandler:
    If Err.Number > 8000 And Err.Number < 8022 Then
        foo = MsgBox("Serial comm error.  Is Sloup running?  Is the cable plugged in?  Is the right COM port selected?", vbExclamation)
        NewtConnect.PortOpen = False
    End If
End Sub

Public Function Replace(ByVal sInputVal As String, _
   sFind As String, sReplaceWith As String) As String

    Dim nPos As Long
    Dim sAns As String
    Dim sWkg As String

    If sFind = "" Then
        'don't change anything **********
        Replace = sInputVal
        Exit Function
    End If

    
    sAns = ""
    sWkg = sInputVal
    
    nPos = InStr(sWkg, sFind)
    
    If nPos <> 0 Then
        Do
            If nPos >= Len(sWkg) Then
                sAns = sAns & Left(sWkg, Len(sWkg) - 1) & _
                    sReplaceWith
            Else
                sAns = sAns & Left(sWkg, nPos - 1) & sReplaceWith
 
                nPos = nPos + Len(sFind) - 1
            End If
                sWkg = Mid(sWkg, nPos + 1)
                nPos = InStr(sWkg, sFind)
                DoEvents
        Loop While nPos > 0
        sAns = sAns & sWkg
    Else
        sAns = sInputVal
    End If
    
    Replace = sAns

End Function


