VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form prefsform 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Preferences"
   ClientHeight    =   5775
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4410
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Moveable        =   0   'False
   ScaleHeight     =   5775
   ScaleWidth      =   4410
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame3 
      Caption         =   "Dates Options"
      Height          =   1815
      Left            =   120
      TabIndex        =   12
      Top             =   1320
      Width           =   3135
      Begin VB.CheckBox repevent_select 
         Caption         =   "Export repeating events?"
         Height          =   255
         Left            =   120
         TabIndex        =   16
         Top             =   1440
         Width           =   2175
      End
      Begin VB.CheckBox repcalendar_select 
         Caption         =   "Export repeating meetings?"
         Height          =   255
         Left            =   120
         TabIndex        =   15
         Top             =   1080
         Width           =   2295
      End
      Begin VB.CheckBox events_select 
         Caption         =   "Export non-repeating events?"
         Height          =   255
         Left            =   120
         TabIndex        =   14
         Top             =   720
         Width           =   2415
      End
      Begin VB.CheckBox calendar_select 
         Caption         =   "Export non-repeating meetings?"
         Height          =   255
         Left            =   120
         TabIndex        =   13
         Top             =   360
         Width           =   2535
      End
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   3840
      Top             =   4560
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Frame Frame1 
      Caption         =   "Data Options"
      Height          =   1095
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   3135
      Begin VB.CheckBox deletedata 
         Caption         =   "Prompt to delete data after dump?"
         Height          =   255
         Left            =   120
         TabIndex        =   11
         Top             =   720
         Width           =   2895
      End
      Begin VB.CheckBox htmlexport 
         Caption         =   "Export as HTML?"
         Enabled         =   0   'False
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   360
         Width           =   1935
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "File Save Options"
      Height          =   2415
      Left            =   120
      TabIndex        =   1
      Top             =   3240
      Width           =   3135
      Begin VB.CommandButton browsebutton 
         Caption         =   "Browse"
         Height          =   255
         Left            =   2040
         TabIndex        =   10
         Top             =   1800
         Width           =   855
      End
      Begin VB.TextBox savedirectory 
         Height          =   285
         Left            =   120
         TabIndex        =   9
         Top             =   2040
         Width           =   2775
      End
      Begin VB.CheckBox subjectfilename 
         Caption         =   "Include subject in filename"
         Enabled         =   0   'False
         Height          =   255
         Left            =   360
         TabIndex        =   6
         Top             =   720
         Width           =   2535
      End
      Begin VB.CheckBox multiplefiles_select 
         Caption         =   "Split into multiple files?"
         Enabled         =   0   'False
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   360
         Width           =   1935
      End
      Begin VB.CheckBox timefilename 
         Caption         =   "Include time in filename"
         Enabled         =   0   'False
         Height          =   255
         Left            =   360
         TabIndex        =   3
         Top             =   1080
         Width           =   2295
      End
      Begin VB.CheckBox datefilename 
         Caption         =   "Include date in filename"
         Enabled         =   0   'False
         Height          =   255
         Left            =   360
         TabIndex        =   2
         Top             =   1440
         Width           =   2295
      End
      Begin VB.Label Label1 
         Caption         =   "Save files to:"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   1800
         Width           =   1935
      End
   End
   Begin VB.CommandButton okbutton 
      Caption         =   "OK"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   3360
      TabIndex        =   0
      Top             =   5160
      Width           =   975
   End
End
Attribute VB_Name = "prefsform"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const PrefsFile As String = "newtdump.ini"

Private Sub browsebutton_Click()
    Dim SaveDir As String
    SaveDir = GetBrowseDirectory(prefsform)
    savedirectory.Text = SaveDir
End Sub

Function GetBrowseDirectory(Owner As Form) As String
   Dim bi As DirBrowse.BROWSEINFO
   Dim IDL As DirBrowse.ITEMIDLIST
   Dim r As Long
   Dim pIdl As Long
   Dim tmpPath As String
   Dim pos As Integer

   bi.hOwner = Owner.hWnd
   bi.pidlRoot = 0&
   bi.lpszTitle = "Choose a directory from the list."
   bi.ulFlags = BIF_RETURNONLYFSDIRS
   pIdl = DirBrowse.SHBrowseForFolder(bi)

   tmpPath = Space$(512)
   r = SHGetPathFromIDList(ByVal pIdl, ByVal tmpPath)

   If r Then
      pos = InStr(tmpPath, Chr$(0))
      tmpPath = Left(tmpPath, pos - 1)

      If Right(tmpPath, 1) <> "\" Then tmpPath = tmpPath & "\"
         GetBrowseDirectory = tmpPath
      Else
         GetBrowseDirectory = ""
      End If

End Function

Private Function GetFile() As String
    '// This function invokes the File dialog to select the file to dump the data to
On Error GoTo cmdClassError
    Dim nFolder As Long
    Dim IDL As ITEMIDLIST
    Dim sPath As String * 260
    Dim SaveFolder As String
    
    '// get the value of the desktop folder
    nFolder = 0
    If SHGetSpecialFolderLocation(Me.hWnd, nFolder, IDL) = 0 Then
        If SHGetPathFromIDList(ByVal IDL.mkid.cb, ByVal sPath) Then
            SaveFolder = Left$(sPath, InStr(sPath, vbNullChar) - 1)
        End If
    End If
    
    '// setup and display the dialog
    With CommonDialog1
        .DialogTitle = "Location of sup.exe"
        .CancelError = True
        .InitDir = SaveFolder
        .Filter = "Executable Files (*.EXE)|*.EXE|Text files (*.TXT)|*.TXT|vCard files (*.vcf)|*.VCF|Package files (*.pkg)|*.PKG|All Files (*.*)|*.*"
        .FilterIndex = 1
        .ShowOpen
                
        GetFile = .filename
        
    End With
    
    Exit Function
    
cmdClassError:
    If (Err.Number <> 20001) Then
'        MsgBox "Error: " & Err.Description
        GetFile = ""
    End If
End Function


Private Sub Form_Load()
    LoadPrefs
    multiplefiles_select_Click
    datefilename.Value = mainform.AutoFileGenDate
    timefilename.Value = mainform.AutoFileGenTime
    subjectfilename.Value = mainform.AutoFileGenSubject
    multiplefiles_select.Value = mainform.MultipleFiles
    htmlexport.Value = mainform.htmlexport
    savedirectory.Text = mainform.savedirectory
    'suplocation.Text = mainform.suplocation
    deletedata.Value = mainform.deletedata
End Sub

Private Sub Form_Unload(Cancel As Integer)
    SavePrefs
    Unload Me
End Sub

Private Sub multiplefiles_select_Click()
    If multiplefiles_select.Value = 1 Then
        datefilename.Enabled = True
        timefilename.Enabled = True
        subjectfilename.Enabled = True
    Else
        datefilename.Enabled = False
        timefilename.Enabled = False
        subjectfilename.Enabled = False
    End If
End Sub

Private Sub okbutton_Click()
    SavePrefs
    Unload Me
End Sub

Private Sub Form_Terminate()
    Unload Me
End Sub

Public Function SavePrefs()
    '// saves the preferences somewhere
    '// to an INI file!  yeah!
    '// valid INI file sections:
    '// [FileOpts] - File saving options
    '//     AutoFileGen - generate filename automatically based on data type being dumped
    '//         AutoFileGenDate - add date to automatic filename
    '//         AutoFileGenTime - add time to automatic filename
    '//         AutoFileGenSubject - add subject to automatic filename
    '//     MultipleFile - write dump as one file per record - AutoFileGen is implied
    '// [DataFmt] - Data format options
    '//     OS1Compat - OS 1.x compatiability mode
    
    Dim FileNum As Integer
    FileNum = FreeFile
    
    mainform.AutoFileGenDate = datefilename.Value
    mainform.AutoFileGenTime = timefilename.Value
    mainform.AutoFileGenSubject = subjectfilename.Value
    mainform.MultipleFiles = multiplefiles_select.Value
    mainform.htmlexport = htmlexport.Value
    'mainform.suplocation = suplocation.Text
    mainform.savedirectory = savedirectory.Text
    mainform.deletedata = deletedata.Value
    
    Open PrefsFile For Output As FileNum
    Print #FileNum, "# DO NOT EDIT THIS FILE!!!!!!"
    Print #FileNum, "[FileOpts]"
    Print #FileNum, "AutoFileGenDate=" & datefilename.Value
    Print #FileNum, "AutoFileGenTime=" & timefilename.Value
    Print #FileNum, "AutoFileGenSubject=" & subjectfilename.Value
    Print #FileNum, "MultipleFile=" & multiplefiles_select.Value
    Print #FileNum, "SaveDirectory=" & prefsform.savedirectory.Text
    'Print #FileNum, "supLocation=" & prefsform.suplocation.Text
    Print #FileNum, ""
    Print #FileNum, "[DataFmt]"
    Print #FileNum, "HTMLExport=" & htmlexport.Value
    Print #FileNum, "DeleteData=" & deletedata.Value
    Close #FileNum
    
End Function

Public Function LoadPrefs()
    Dim FileNum As Integer
    Dim CurrentLine As String

    FileNum = FreeFile
    
    Open PrefsFile For Input As FileNum
    Do Until EOF(FileNum)
        Line Input #FileNum, CurrentLine
        If CurrentLine Like "[[]*" Then
            '// do nothing
        ElseIf CurrentLine Like "AutoFileGenDate=#" Then
            datefilename.Value = Right(CurrentLine, 1)
            mainform.AutoFileGenDate = Right(CurrentLine, 1)
        ElseIf CurrentLine Like "AutoFileGenTime=#" Then
            timefilename.Value = Right(CurrentLine, 1)
            mainform.AutoFileGenTime = Right(CurrentLine, 1)
        ElseIf CurrentLine Like "AutoFileGenSubject=#" Then
            subjectfilename.Value = Right(CurrentLine, 1)
            mainform.AutoFileGenSubject = Right(CurrentLine, 1)
        ElseIf CurrentLine Like "MultipleFile=#" Then
            multiplefiles_select.Value = Right(CurrentLine, 1)
            mainform.MultipleFiles = Right(CurrentLine, 1)
        ElseIf CurrentLine Like "DeleteData=#" Then
            deletedata.Value = Right(CurrentLine, 1)
            mainform.deletedata = Right(CurrentLine, 1)
        ElseIf CurrentLine Like "HTMLExport=#" Then
            htmlexport.Value = Right(CurrentLine, 1)
            mainform.htmlexport = Right(CurrentLine, 1)
        ElseIf Left(CurrentLine, 14) = "SaveDirectory=" Then
            savedirectory.Text = Right(CurrentLine, Len(CurrentLine) - 14)
            mainform.savedirectory = Right(CurrentLine, Len(CurrentLine) - 14)
        'ElseIf Left(CurrentLine, 12) = "supLocation=" Then
        '    suplocation.Text = Right(CurrentLine, Len(CurrentLine) - 12)
        '    mainform.suplocation = Right(CurrentLine, Len(CurrentLine) - 12)
        Else
            '// do nothing
        End If
    Loop
    
    Close #FileNum
    
End Function
