Attribute VB_Name = "TZInfo"
Option Explicit

'// Time Zone API Declarations
Public Const TIME_ZONE_ID_UNKNOWN = 0
Public Const TIME_ZONE_ID_STANDARD = 1
Public Const TIME_ZONE_ID_INVALID = &HFFFFFFFF
Public Const TIME_ZONE_ID_DAYLIGHT = 2

Public Type SYSTEMTIME
    wYear(1 To 2) As Byte
    wMonth(1 To 2) As Byte
    wDayOfWeek(1 To 2) As Byte
    wDay(1 To 2) As Byte
    wHour(1 To 2) As Byte
    wMinute(1 To 2) As Byte
    wSecond(1 To 2) As Byte
    wMilliseconds(1 To 2) As Byte
End Type

Public Type TIME_ZONE_INFORMATION
    bias As Long                        '// current offset to GMT
    StandardName(1 To 64) As Byte       '// unicode string
    StandardDate As SYSTEMTIME
    StandardBias As Long
    DaylightName(1 To 64) As Byte
    DaylightDate As SYSTEMTIME
    DaylightBias As Long
End Type

Public Declare Sub GetSystemTime Lib "kernel32" (lpSystemTime As SYSTEMTIME)

Public Declare Function GetTimeZoneInformation Lib "kernel32" (lpTimeZoneInformation As TIME_ZONE_INFORMATION) As Long

