Attribute VB_Name = "Tokenizer"
Option Explicit

Function Piece(ByVal Text$, ByVal separator$, ByVal from As Integer, ByVal thru As Integer) As String
    
    Dim i As Integer, Temp As String, result As String
    Dim PieceBegin As Integer, t As Integer, Count As Integer
    Dim PieceEnd As Integer, Found As Integer
    
    Piece = ""
    If Text$ = "" Then Exit Function
    If separator$ = "" Then Exit Function
    If Not (from > 0) Then from = 1
    If thru < from Then thru = from
    'Find first instance of the separator
     t = InStr(1, Text$, separator$)
    
    'If no occurence return original string and exit
    If t = 0 Then
    Piece = Text$
    Exit Function
    End If

    'If first piece, return left most data and exit

    If (from = 1) And (from = thru) Then
    If t = 1 Then
        Piece = ""
        Exit Function
    Else
        Piece = Left$(Text$, t - 1)
        Exit Function
    End If
    End If
    
    PieceBegin = 1
    For i = 1 To from - 1
       t = InStr(PieceBegin, Text$, separator)
       If t = 0 Then Exit For
       PieceBegin = t + 1
       Next i
    
    ' If there is no separator exit function with "" result
    If t = 0 Then Exit Function
    
    'If only one piece to return, find it and exit
    If from = thru Then
    t = InStr(PieceBegin, Text$, separator)
    If t = 0 Then t = Len(Text$) + 1
    result = Left$(Text$, t - 1)
    Piece = Right$(result, t - PieceBegin)
    Exit Function
    End If
    
    'Find last piece then exit

    PieceEnd = t + 1
    If from = 1 Then from = 2
    For i = from To thru

    t = InStr(PieceEnd, Text$, separator)
    If t = 0 Then
        t = Len(Text$) + 1
        Exit For
    End If
    PieceEnd = t + 1
    Next i
    If t = 0 Then t = Len(Text$) + 1
    result = Left$(Text$, t - 1)
    Piece = Right$(result, t - PieceBegin)

End Function

